------------------------
-- Kevin Depue (2010) --
-- Backflip Studios   --
--                    --
-- Visitors           --
------------------------

-- module --
module(...,package.seeall)

-- The generic visitor.
function visit( root, callback )
	local function recurser( inner )
		callback( inner )
		
		for i = 0, inner:getNumOwned() - 1 do
			local child = inner:getOwned( i )
			
			if child ~= nil then
				recurser( child )
			end
		end
	end
	
	recurser( root )
end