------------------------
-- Kevin Depue (2010) --
-- Backflip Studios   --
--                    --
-- Pool               --
------------------------

-- module --
module(...,package.seeall)

-- The globals.
local the_v2i           = v2i( 0, 0 )
local the_v2f           = v2f( 0.0, 0.0 )
local the_v3f           = v3f( 0.0, 0.0, 0.0 )
local the_colorf        = colorf( 0.0, 0.0, 0.0, 0.0 )

-- Get a v2i.
function get_v2i( x, y )
	local v = the_v2i

	v.x = x
	v.y = y
	
	return v
end

-- Get a v2f.
function get_v2f( x, y )
	local v = the_v2f
	
	v.x = x
	v.y = y
	
	return v
end

-- Get a v3f.
function get_v3f( x, y, z )
	local v = the_v3f
	
	v.x = x
	v.y = y
	v.z = z
	
	return v
end

-- Get a colorf.
function get_colorf( r, g, b, a )
	local c = the_colorf
	
	c.r = r
	c.g = g
	c.b = b
	c.a = a
	
	return c
end


