------------------------
-- Kevin Depue (2010) --
-- Backflip Studios   --
--                    --
-- Textures           --
------------------------

module(...,package.seeall)

-- Sets both a texture and sprite size.
function setTexture( actor, texture )
	if texture ~= nil then
		actor.texture = texture.path
		actor.size    = texture.size
	end
	
	if actor.texture == nil then
		print( debug.traceback( "error: unable to set texture!" ) )
	end
end	
